﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 1100;
			fibonacci	= 1/1.1;
			accident	= .998;
			rapport 	= 360-360*fibonacci - 10;
			rad 		= 500;
			growth		= 1.007;
			sc_x		= 0;
			sc_y		= 0;
			rpx			= 7;
			rpy			= 1.050;
		
			cur			= max;
			rot			= 0;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK,click_handler);
			//stage.addEventListener(MouseEvent.MOUSE_OVER,up_handler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		
		
		private function click_handler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				//rapport*=accident;
				sc_x*=rad;
				sc_y*=rot;
				rot += rapport;
				rot-= new int(rot/360)*360;
				rad/=growth;
				var y:Number = stage.stageWidth/2-Math.cos(rot * Math.PI/90) *rad;
				var x:Number = stage.stageHeight/2-Math.sin(rot * Math.PI/90) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(1,0x999999,.4);
					graphics.lineTo(x,y);
					//rotation= Math.random()*360;
					graphics.drawEllipse(x,y,2,15);
				}else{
					graphics.moveTo(x,y);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}